package gotowe.p03_instrukcje.c_switch;

import javax.swing.JOptionPane;

public class IleDniMaMiesiac5 {

    public static void main(String[] args) {
        try {
            String miesiac = JOptionPane.showInputDialog("Podaj nazwę miesiąca");
    
            int ileDni = switch(miesiac) {
                // w ramach switch expression, jeśli po wybraniu case'a wiemy od razu, jaki ma być wynik,
                // to po prostu piszemy go za -> strzałką
                case "styczeń", "marzec", "maj", "lipiec", "sierpień", "październik", "grudzień" -> 31;
                case "kwiecień", "czerwiec", "wrzesień", "listopad" -> 30;

                // ale jeśli w danym case jest więkcej kroków do wykonania,
                // to wynik switcha zwracamy za pomocą słowa yield
                case "luty" -> {
                    int rok = Integer.parseInt(JOptionPane.showInputDialog("Podaj rok"));
                    if(rok % 4 == 0 && rok % 100 != 0 || rok % 400 == 0) {
                        yield 29;
                    } else {
                        yield 28;
                    }
                }
                default -> throw new IllegalArgumentException("Niepoprawny miesiąc");
            };
            
            JOptionPane.showMessageDialog(null, "Miesiąc " + miesiac + " ma " + ileDni + " dni.");
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, e.getMessage(), "Błąd", JOptionPane.ERROR_MESSAGE);
        }
        
        // przy okazji - nowe instrukcje Javy mają status "identyfikatora o specjalym znaczeniu" a nie "słowa kluczowego"
        // to znaczy, że w innych miejscach działają jak zwykłe nazwy; mogą być używane np. dla zmiennych
        boolean yield = true;
        var var = 15;
        if(yield) {
            JOptionPane.showMessageDialog(null, var);
        }
    }

}
